<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Index extends Controller_UserEnvironment
{
    public function action_index() {
        $teacher = Model_Teacher::with($this->user['TeacherID']);
        $disciplines = $teacher->getDisciplines();

        $subjID = $discID = $gradeNum = $i = $j = $k = 0; // Combo!!!
        $disciplinesHandled = array();
        $groupsInDiscipline = array();
        
        foreach ($disciplines as $dis) {
            if($subjID != $dis->subjectID || $gradeNum != $dis->gradeID) {
                $i++;
                $j = $k = 0;
                $subjID = $dis->subjectID;
                $gradeNum = $dis->gradeID;

                $groupsInDiscipline = array();
                $disciplinesHandled[$i] = [
                    'subjectName' => $dis->subjectName,
                    'gradeNum' => $dis->gradeNum,
                    'degree' => Model_Grades::getDegreeTitle($dis->degree),
                ];
            }
            
            if ($discID != $dis->ID) {
                $j++;
                $k = 0;

                $groupsInDiscipline = array();
                $row =& $disciplinesHandled[$i]['Disciplines'][$j];

                $row['isAuthor'] = $this->user['TeacherID'] == $dis->authorID;
                $row['isLocked'] = $dis->isLocked;
                $row['isMapCreated'] = $dis['isMapCreated'];
                $row['ID'] = $discID = $dis->ID;

                $row['control'] = DataHelper::LocalizeExamType($dis->type, $dis->subtype);
                $row['teachers'] = ($dis->subtype == 'scientific_coursework')
                    ? ['Сотрудники кафедры'] : self::getTeachersForDiscipline($dis->ID);
            }

            if ($dis['groupNum'])
                $groupsInDiscipline[++$k] = $dis['groupNum'] . ' гр.';

            $disciplinesHandled[$i]['Disciplines'][$j]['groups'] = implode(', ', $groupsInDiscipline);
        } //!for_each

        $this->twig->set([
            'Subjects'     => $disciplinesHandled,
            'SemesterList' => Model_Semesters::toArray(),
            'Semester'     => $this->SemesterInfo,
        ])->set_filename('teacher/index');
    }
    
    public function action_settings() {
        $this->twig->set_filename('settings');
    }

    protected function getTeachersForDiscipline($id) {
        $teachers = Model_Discipline::load($id)->getTeachers();
        $list = array();
        $i = 0;
        foreach ($teachers as $teacher) {
            $i++;
            $list[$i] = $teacher['LastName'] . ' ' . UTF8::substr($teacher['FirstName'], 0, 1) . '. ';
            if (!empty($teacher['SecondName'])) {
                $list[$i] .= UTF8::substr($teacher['SecondName'], 0, 1) . '.';
            }
        }
        return $list;
    }
}